<?php

if (function_exists('pcntl_async_signals')) {
    define("SIGNALS_ASYNC", true);
    pcntl_async_signals(true);
} else {
    define("SIGNALS_ASYNC", false);
}

// Signal shims
defined("SIGHUP")    || define("SIGHUP",    1);  // Hangup (POSIX)
defined("SIGINT")    || define("SIGINT",    2);  // Terminal interrupt (ANSI)
defined("SIGQUIT")   || define("SIGQUIT",   3);  // Terminal quit (POSIX)
defined("SIGILL")    || define("SIGILL",    4);  // Illegal instruction (ANSI)
defined("SIGTRAP")   || define("SIGTRAP",   5);  // Trace trap (POSIX)
defined("SIGIOT")    || define("SIGIOT",    6);  // IOT Trap (4.2 BSD)
defined("SIGBUS")    || define("SIGBUS",    7);  // BUS error (4.2 BSD)
defined("SIGFPE")    || define("SIGFPE",    8);  // Floating point exception (ANSI)
defined("SIGKILL")   || define("SIGKILL",   9);  // Kill(can't be caught or ignored) (POSIX)
defined("SIGUSR1")   || define("SIGUSR1",   10); // User defined signal 1 (POSIX)
defined("SIGSEGV")   || define("SIGSEGV",   11); // Invalid memory segment access (ANSI)
defined("SIGUSR2")   || define("SIGUSR2",   12); // User defined signal 2 (POSIX)
defined("SIGPIPE")   || define("SIGPIPE",   13); // Write on a pipe with no reader, Broken pipe (POSIX)
defined("SIGALRM")   || define("SIGALRM",   14); // Alarm clock (POSIX)
defined("SIGTERM")   || define("SIGTERM",   15); // Termination (ANSI)
defined("SIGSTKFLT") || define("SIGSTKFLT", 16); // Stack fault
defined("SIGCHLD")   || define("SIGCHLD",   17); // Child process has stopped or exited, changed (POSIX)
defined("SIGCONT")   || define("SIGCONT",   18); // Continue executing, if stopped (POSIX)
defined("SIGSTOP")   || define("SIGSTOP",   19); // Stop executing(can't be caught or ignored) (POSIX)
defined("SIGTSTP")   || define("SIGTSTP",   20); // Terminal stop signal (POSIX)
defined("SIGTTIN")   || define("SIGTTIN",   21); // Background process trying to read, from TTY (POSIX)
defined("SIGTTOU")   || define("SIGTTOU",   22); // Background process trying to write, to TTY (POSIX)
defined("SIGURG")    || define("SIGURG",    23); // Urgent condition on socket (4.2 BSD)
defined("SIGXCPU")   || define("SIGXCPU",   24); // CPU limit exceeded (4.2 BSD)
defined("SIGXFSZ")   || define("SIGXFSZ",   25); // File size limit exceeded (4.2 BSD)
defined("SIGVTALRM") || define("SIGVTALRM", 26); // Virtual alarm clock (4.2 BSD)
defined("SIGPROF")   || define("SIGPROF",   27); // Profiling alarm clock (4.2 BSD)
defined("SIGWINCH")  || define("SIGWINCH",  28); // Window size change (4.3 BSD, Sun)
defined("SIGIO")     || define("SIGIO",     29); // I/O now possible (4.2 BSD)
defined("SIGPWR")    || define("SIGPWR",    30); // Power failure restart (System V)

